"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Config {
    constructor() {
        const PORT = process.env.PORT || '6805';
        this.serverOptions = {
            debug: process.env.SILEX_DEBUG === 'true',
            port: PORT,
            rootUrl: process.env.SERVER_URL || `http://localhost:${PORT}`,
            sessionSecret: process.env.SILEX_SESSION_SECRET || 'test session secret',
            cePath: '/ce',
        };
        this.electronOptions = {
            enabled: process.env.SILEX_ELECTRON === 'true',
        };
        this.sslOptions = {
            forceHttps: process.env.SILEX_FORCE_HTTPS === 'true',
            trustXFPHeader: process.env.SILEX_FORCE_HTTPS_TRUST_XFP_HEADER === 'true',
            privateKey: process.env.SILEX_SSL_PRIVATE_KEY,
            certificate: process.env.SILEX_SSL_CERTIFICATE,
            sslPort: process.env.SSL_PORT || '443',
        };
        this.ceOptions = {
            enableFtp: process.env.ENABLE_FTP === 'true',
            enableSftp: process.env.ENABLE_SFTP !== 'false',
            enableWebdav: process.env.ENABLE_WEBDAV === 'true',
            githubClientId: process.env.GITHUB_CLIENT_ID,
            githubClientSecret: process.env.GITHUB_CLIENT_SECRET,
            dropboxClientId: process.env.DROPBOX_CLIENT_ID,
            dropboxClientSecret: process.env.DROPBOX_CLIENT_SECRET,
            enableFs: this.serverOptions.debug || this.electronOptions.enabled || process.env.ENABLE_FS === 'true',
            fsRoot: process.env.FS_ROOT,
            rootUrl: this.serverOptions.rootUrl + this.serverOptions.cePath,
        };
        this.publisherOptions = {
            rootUrl: this.serverOptions.rootUrl,
            port: this.serverOptions.port,
            skipHostingSelection: process.env.SKIP_HOSTING_SELECTION === 'true',
            enableHostingGhPages: process.env.ENABLE_HOSTING_GH_PAGES === 'true',
            enableHostingUnifile: process.env.ENABLE_HOSTING_UNIFILE !== 'false',
            enableHostingJekyll: process.env.ENABLE_HOSTING_JEKYLL === 'true',
        };
        this.staticOptions = {};
    }
}
exports.Config = Config;
