'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
const electron_1 = require("electron");
const Path = require("path");
const Url = require("url");
let win;
function createWindow() {
    win = new electron_1.BrowserWindow({
        width: 1200,
        height: 800,
        minWidth: 950,
        minHeight: 630,
        icon: Path.join(__dirname, '..', 'client', 'assets', 'logo-silex.png'),
        titleBarStyle: 'hidden',
        webPreferences: {
            nodeIntegration: false,
            sandbox: true,
        },
    });
    const url = 'http://localhost:' + (process.env.PORT || 6805) + '/';
    console.log('Sarting app on ' + url);
    win.loadURL(url);
    win.on('closed', () => {
        win = null;
    });
}
electron_1.app.on('ready', createWindow);
electron_1.app.on('window-all-closed', () => {
    if (process.platform !== 'darwin') {
        electron_1.app.quit();
    }
});
electron_1.app.on('activate', () => {
    if (win === null) {
        createWindow();
    }
});
electron_1.app.on('ready', () => {
    electron_1.protocol.registerFileProtocol('silex', (request, callback) => {
        const pathname = Url.parse(request.url).pathname.replace('home/home', 'home');
        callback(pathname);
    }, (error) => {
        if (error) {
            console.error('Failed to register protocol');
        }
    });
});
electron_1.app.on('browser-window-created', (e, window) => {
    window.setMenu(null);
});
